Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -2793,244 +3290,243 @@
                     next_tree->header.num_items--;
                     t->header.num_items++;
                 }
-                
+
                 changed = TRUE;
             } else
                 break;
-            
+
             le = next_tree->itemlist.Flink;
         }
-        
+
         le = next_tree->itemlist.Flink;
         while (le != &next_tree->itemlist) {
             tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-            
+
             if (!td->ignore) {
                 firstitem = td->key;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
-//         ERR("firstitem = %llx,%x,%llx\n", firstitem.obj_id, firstitem.obj_type, firstitem.offset);
-        
+
         // FIXME - once ascension is working, make this work with parent's parent, etc.
         if (next_tree->paritem)
             next_tree->paritem->key = firstitem;
-        
+
         par = next_tree;
         while (par) {
             par->write = TRUE;
             par = par->parent;
         }
-            
+
         if (changed)
             *done = TRUE;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS update_extent_level(device_extension* Vcb, UINT64 address, tree* t, UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS update_extent_level(device_extension* Vcb, UINT64 address, tree* t, UINT8 level, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA) {
         searchkey.obj_id = address;
         searchkey.obj_type = TYPE_METADATA_ITEM;
         searchkey.offset = t->header.level;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (!keycmp(tp.item->key, searchkey)) {
             EXTENT_ITEM_SKINNY_METADATA* eism;
-            
+
             if (tp.item->size > 0) {
                 eism = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
-                
+
                 if (!eism) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(eism, tp.item->data, tp.item->size);
             } else
                 eism = NULL;
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, eism, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                ExFreePool(eism);
-                return STATUS_INTERNAL_ERROR;
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                if (eism) ExFreePool(eism);
+                return Status;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, eism, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                if (eism) ExFreePool(eism);
+                return Status;
+            }
+
             return STATUS_SUCCESS;
         }
     }
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
         EXTENT_ITEM_TREE* eit;
-        
+
         if (tp.item->size < sizeof(EXTENT_ITEM_TREE)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM_TREE));
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         eit = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
-                
+
         if (!eit) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(eit, tp.item->data, tp.item->size);
-        
-        delete_tree_item(Vcb, &tp, rollback);
-        
+
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            ExFreePool(eit);
+            return Status;
+        }
+
         eit->level = level;
-        
-        if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, eit, tp.item->size, NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
+
+        Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, eit, tp.item->size, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             ExFreePool(eit);
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
-    
+
         return STATUS_SUCCESS;
     }
-    
+
     ERR("could not find EXTENT_ITEM for address %llx\n", address);
-    
+
     return STATUS_INTERNAL_ERROR;
 }
 
 static NTSTATUS update_tree_extents_recursive(device_extension* Vcb, tree* t, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
-    
+
     if (t->parent && !t->parent->updated_extents && t->parent->has_address) {
         Status = update_tree_extents_recursive(Vcb, t->parent, Irp, rollback);
         if (!NT_SUCCESS(Status))
             return Status;
     }
-    
+
     Status = update_tree_extents(Vcb, t, Irp, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("update_tree_extents returned %08x\n", Status);
         return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL do_splits(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
-//     LIST_ENTRY *le, *le2;
-//     write_tree* wt;
-//     tree_data* td;
-    UINT8 level, max_level;
+static NTSTATUS do_splits(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+    ULONG level, max_level;
     UINT32 min_size;
     BOOL empty, done_deletions = FALSE;
     NTSTATUS Status;
     tree* t;
-    
+
     TRACE("(%p)\n", Vcb);
-    
+
     max_level = 0;
-    
+
     for (level = 0; level <= 255; level++) {
         LIST_ENTRY *le, *nextle;
-        
+
         empty = TRUE;
-        
+
         TRACE("doing level %u\n", level);
-        
+
         le = Vcb->trees.Flink;
-    
+
         while (le != &Vcb->trees) {
             t = CONTAINING_RECORD(le, tree, list_entry);
-            
+
             nextle = le->Flink;
-            
+
             if (t->write && t->header.level == level) {
                 empty = FALSE;
-                
+
                 if (t->header.num_items == 0) {
-                    if (!t->updated_extents && t->has_address) {
-                        Status = update_tree_extents(Vcb, t, Irp, rollback);
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("update_tree_extents returned %08x\n", Status);
-                            return Status;
-                        }
-                    }
-
                     if (t->parent) {
                         done_deletions = TRUE;
-            
+
                         TRACE("deleting tree in root %llx\n", t->root->id);
-                        
+
                         t->root->root_item.bytes_used -= Vcb->superblock.node_size;
-                        
+
                         if (t->has_new_address) { // delete associated EXTENT_ITEM
                             Status = reduce_tree_extent(Vcb, t->new_address, t, t->parent->header.tree_id, t->header.level, Irp, rollback);
-                            
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("reduce_tree_extent returned %08x\n", Status);
                                 return Status;
                             }
-                            
+
                             t->has_new_address = FALSE;
                         } else if (t->has_address) {
                             Status = reduce_tree_extent(Vcb,t->header.address, t, t->parent->header.tree_id, t->header.level, Irp, rollback);
-                            
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("reduce_tree_extent returned %08x\n", Status);
                                 return Status;
                             }
-                            
+
                             t->has_address = FALSE;
                         }
-                        
+
                         if (!t->paritem->ignore) {
                             t->paritem->ignore = TRUE;
                             t->parent->header.num_items--;
                             t->parent->size -= sizeof(internal_node);
                         }
-                        
+
                         RemoveEntryList(&t->paritem->list_entry);
                         ExFreePool(t->paritem);
                         t->paritem = NULL;
-                        
+
                         free_tree(t);
                     } else if (t->header.level != 0) {
                         if (t->has_new_address) {
-                            Status = update_extent_level(Vcb, t->new_address, t, 0, Irp, rollback);
-                            
+                            Status = update_extent_level(Vcb, t->new_address, t, 0, Irp);
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("update_extent_level returned %08x\n", Status);
                                 return Status;
                             }
                         }
-                        
+
                         t->header.level = 0;
                     }
                 } else if (t->size > Vcb->superblock.node_size - sizeof(tree_header)) {
                     TRACE("splitting overlarge tree (%x > %x)\n", t->size, Vcb->superblock.node_size - sizeof(tree_header));
-                    
+
                     if (!t->updated_extents && t->has_address) {
                         Status = update_tree_extents_recursive(Vcb, t, Irp, rollback);
                         if (!NT_SUCCESS(Status)) {
@@ -3038,7 +3534,7 @@
                             return Status;
                         }
                     }
-                    
+
                     Status = split_tree(Vcb, t);
 
                     if (!NT_SUCCESS(Status)) {
@@ -3047,10 +3543,10 @@
                     }
                 }
             }
-            
+
             le = nextle;
         }
-        
+
         if (!empty) {
             max_level = level;
         } else {
@@ -3058,22 +3554,23 @@
             break;
         }
     }
-    
+
     min_size = (Vcb->superblock.node_size - sizeof(tree_header)) / 2;
-    
+
     for (level = 0; level <= max_level; level++) {
         LIST_ENTRY* le;
-        
+
         le = Vcb->trees.Flink;
-    
+
         while (le != &Vcb->trees) {
             t = CONTAINING_RECORD(le, tree, list_entry);
-            
-            if (t->write && t->header.level == level && t->header.num_items > 0 && t->parent && t->size < min_size && is_tree_unique(Vcb, t, Irp)) {
+
+            if (t->write && t->header.level == level && t->header.num_items > 0 && t->parent && t->size < min_size &&
+                t->root->id != BTRFS_ROOT_FREE_SPACE && is_tree_unique(Vcb, t, Irp)) {
                 BOOL done;
-                
+
                 do {
-                    Status = try_tree_amalgamate(Vcb, t, &done, Irp, rollback);
+                    Status = try_tree_amalgamate(Vcb, t, &done, &done_deletions, Irp, rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("try_tree_amalgamate returned %08x\n", Status);
                         return Status;
@@ -3080,26 +3577,26 @@
                     }
                 } while (done && t->size < min_size);
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
     // simplify trees if top tree only has one entry
-    
+
     if (done_deletions) {
         for (level = max_level; level > 0; level--) {
             LIST_ENTRY *le, *nextle;
-            
+
             le = Vcb->trees.Flink;
             while (le != &Vcb->trees) {
                 nextle = le->Flink;
                 t = CONTAINING_RECORD(le, tree, list_entry);
-                
+
                 if (t->write && t->header.level == level) {
                     if (!t->parent && t->header.num_items == 1) {
                         LIST_ENTRY* le2 = t->itemlist.Flink;
-                        tree_data* td;
+                        tree_data* td = NULL;
                         tree* child_tree = NULL;
 
                         while (le2 != &t->itemlist) {
@@ -3108,33 +3605,33 @@
                                 break;
                             le2 = le2->Flink;
                         }
-                        
+
                         TRACE("deleting top-level tree in root %llx with one item\n", t->root->id);
-                        
+
                         if (t->has_new_address) { // delete associated EXTENT_ITEM
                             Status = reduce_tree_extent(Vcb, t->new_address, t, t->header.tree_id, t->header.level, Irp, rollback);
-                            
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("reduce_tree_extent returned %08x\n", Status);
                                 return Status;
                             }
-                            
+
                             t->has_new_address = FALSE;
                         } else if (t->has_address) {
                             Status = reduce_tree_extent(Vcb,t->header.address, t, t->header.tree_id, t->header.level, Irp, rollback);
-                            
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("reduce_tree_extent returned %08x\n", Status);
                                 return Status;
                             }
-                            
+
                             t->has_address = FALSE;
                         }
-                        
+
                         if (!td->treeholder.tree) { // load first item if not already loaded
                             KEY searchkey = {0,0,0};
                             traverse_ptr tp;
-                            
+
                             Status = find_item(Vcb, t->root, &tp, &searchkey, FALSE, Irp);
                             if (!NT_SUCCESS(Status)) {
                                 ERR("error - find_item returned %08x\n", Status);
@@ -3141,62 +3638,62 @@
                                 return Status;
                             }
                         }
-                        
+
                         child_tree = td->treeholder.tree;
-                        
+
                         if (child_tree) {
                             child_tree->parent = NULL;
                             child_tree->paritem = NULL;
                         }
-                        
+
                         t->root->root_item.bytes_used -= Vcb->superblock.node_size;
 
                         free_tree(t);
-                        
+
                         if (child_tree)
                             child_tree->root->treeholder.tree = child_tree;
                     }
                 }
-                
+
                 le = nextle;
             }
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
 static NTSTATUS remove_root_extents(device_extension* Vcb, root* r, tree_holder* th, UINT8 level, tree* parent, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
-    
+
     if (!th->tree) {
-        Status = load_tree(Vcb, th->address, r, &th->tree, NULL, NULL);
-        
+        Status = load_tree(Vcb, th->address, r, &th->tree, th->generation, NULL);
+
         if (!NT_SUCCESS(Status)) {
             ERR("load_tree(%llx) returned %08x\n", th->address, Status);
             return Status;
         }
     }
-    
+
     if (level > 0) {
         LIST_ENTRY* le = th->tree->itemlist.Flink;
-        
+
         while (le != &th->tree->itemlist) {
             tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-            
+
             if (!td->ignore) {
                 Status = remove_root_extents(Vcb, r, &td->treeholder, th->tree->header.level - 1, th->tree, Irp, rollback);
-                
+
                 if (!NT_SUCCESS(Status)) {
                     ERR("remove_root_extents returned %08x\n", Status);
                     return Status;
                 }
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
     if (th->tree && !th->tree->updated_extents && th->tree->has_address) {
         Status = update_tree_extents(Vcb, th->tree, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
@@ -3204,16 +3701,16 @@
             return Status;
         }
     }
-    
+
     if (!th->tree || th->tree->has_address) {
         Status = reduce_tree_extent(Vcb, th->address, NULL, parent ? parent->header.tree_id : r->id, level, Irp, rollback);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("reduce_tree_extent(%llx) returned %08x\n", th->address, Status);
             return Status;
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3221,53 +3718,126 @@
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
-    
+
     Status = remove_root_extents(Vcb, r, &r->treeholder, r->root_item.root_level, NULL, Irp, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("remove_root_extents returned %08x\n", Status);
         return Status;
     }
-    
-    // remove entry in uuid root (tree 9)
+
+    // remove entries in uuid root (tree 9)
     if (Vcb->uuid_root) {
         RtlCopyMemory(&searchkey.obj_id, &r->root_item.uuid.uuid[0], sizeof(UINT64));
         searchkey.obj_type = TYPE_SUBVOL_UUID;
         RtlCopyMemory(&searchkey.offset, &r->root_item.uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
-        
+
         if (searchkey.obj_id != 0 || searchkey.offset != 0) {
             Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 WARN("find_item returned %08x\n", Status);
             } else {
-                if (!keycmp(tp.item->key, searchkey))
-                    delete_tree_item(Vcb, &tp, rollback);
-                else
+                if (!keycmp(tp.item->key, searchkey)) {
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+                } else
                     WARN("could not find (%llx,%x,%llx) in uuid tree\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
             }
         }
+
+        if (r->root_item.rtransid > 0) {
+            RtlCopyMemory(&searchkey.obj_id, &r->root_item.received_uuid.uuid[0], sizeof(UINT64));
+            searchkey.obj_type = TYPE_SUBVOL_REC_UUID;
+            RtlCopyMemory(&searchkey.offset, &r->root_item.received_uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
+
+            Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
+            if (!NT_SUCCESS(Status))
+                WARN("find_item returned %08x\n", Status);
+            else {
+                if (!keycmp(tp.item->key, searchkey)) {
+                    if (tp.item->size == sizeof(UINT64)) {
+                        UINT64* id = (UINT64*)tp.item->data;
+
+                        if (*id == r->id) {
+                            Status = delete_tree_item(Vcb, &tp);
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("delete_tree_item returned %08x\n", Status);
+                                return Status;
+                            }
+                        }
+                    } else if (tp.item->size > sizeof(UINT64)) {
+                        ULONG i;
+                        UINT64* ids = (UINT64*)tp.item->data;
+
+                        for (i = 0; i < tp.item->size / sizeof(UINT64); i++) {
+                            if (ids[i] == r->id) {
+                                UINT64* ne;
+
+                                ne = ExAllocatePoolWithTag(PagedPool, tp.item->size - sizeof(UINT64), ALLOC_TAG);
+                                if (!ne) {
+                                    ERR("out of memory\n");
+                                    return STATUS_INSUFFICIENT_RESOURCES;
+                                }
+
+                                if (i > 0)
+                                    RtlCopyMemory(ne, ids, sizeof(UINT64) * i);
+
+                                if ((i + 1) * sizeof(UINT64) < tp.item->size)
+                                    RtlCopyMemory(&ne[i], &ids[i + 1], tp.item->size - ((i + 1) * sizeof(UINT64)));
+
+                                Status = delete_tree_item(Vcb, &tp);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("delete_tree_item returned %08x\n", Status);
+                                    ExFreePool(ne);
+                                    return Status;
+                                }
+
+                                Status = insert_tree_item(Vcb, Vcb->uuid_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
+                                                          ne, tp.item->size - sizeof(UINT64), NULL, Irp);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("insert_tree_item returned %08x\n", Status);
+                                    ExFreePool(ne);
+                                    return Status;
+                                }
+
+                                break;
+                            }
+                        }
+                    }
+                } else
+                    WARN("could not find (%llx,%x,%llx) in uuid tree\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
+            }
+        }
     }
-    
+
     // delete ROOT_ITEM
-    
+
     searchkey.obj_id = r->id;
     searchkey.obj_type = TYPE_ROOT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         return Status;
     }
-    
-    if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type)
-        delete_tree_item(Vcb, &tp, rollback);
-    else
+
+    if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
+        Status = delete_tree_item(Vcb, &tp);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    } else
         WARN("could not find (%llx,%x,%llx) in root_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
-    
+
     // delete items in tree cache
-    
+
     free_trees_root(Vcb, r);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3274,60 +3844,66 @@
 static NTSTATUS drop_roots(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
     LIST_ENTRY *le = Vcb->drop_roots.Flink, *le2;
     NTSTATUS Status;
-    
+
     while (le != &Vcb->drop_roots) {
         root* r = CONTAINING_RECORD(le, root, list_entry);
-        
+
         le2 = le->Flink;
-        
+
         Status = drop_root(Vcb, r, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("drop_root(%llx) returned %08x\n", r->id, Status);
             return Status;
         }
-        
+
         le = le2;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS update_dev_item(device_extension* Vcb, device* device, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS update_dev_item(device_extension* Vcb, device* device, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     DEV_ITEM* di;
     NTSTATUS Status;
-    
+
     searchkey.obj_id = 1;
     searchkey.obj_type = TYPE_DEV_ITEM;
     searchkey.offset = device->devitem.dev_id;
-    
+
     Status = find_item(Vcb, Vcb->chunk_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (keycmp(tp.item->key, searchkey)) {
         ERR("error - could not find DEV_ITEM for device %llx\n", device->devitem.dev_id);
         return STATUS_INTERNAL_ERROR;
     }
-    
-    delete_tree_item(Vcb, &tp, rollback);
-    
+
+    Status = delete_tree_item(Vcb, &tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     di = ExAllocatePoolWithTag(PagedPool, sizeof(DEV_ITEM), ALLOC_TAG);
     if (!di) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(di, &device->devitem, sizeof(DEV_ITEM));
-    
-    if (!insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, device->devitem.dev_id, di, sizeof(DEV_ITEM), NULL, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+
+    Status = insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, device->devitem.dev_id, di, sizeof(DEV_ITEM), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(di);
+        return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3335,33 +3911,33 @@
     sys_chunk* sc2;
     USHORT i = 0;
     LIST_ENTRY* le;
-    
+
     i = 0;
     le = Vcb->sys_chunks.Flink;
     while (le != &Vcb->sys_chunks) {
         sc2 = CONTAINING_RECORD(le, sys_chunk, list_entry);
-        
+
         TRACE("%llx,%x,%llx\n", sc2->key.obj_id, sc2->key.obj_type, sc2->key.offset);
-        
+
         RtlCopyMemory(&Vcb->superblock.sys_chunk_array[i], &sc2->key, sizeof(KEY));
         i += sizeof(KEY);
-        
+
         RtlCopyMemory(&Vcb->superblock.sys_chunk_array[i], sc2->data, sc2->size);
         i += sc2->size;
-        
+
         le = le->Flink;
     }
 }
 
-static NTSTATUS add_to_bootstrap(device_extension* Vcb, UINT64 obj_id, UINT8 obj_type, UINT64 offset, void* data, ULONG size) {
-    sys_chunk *sc, *sc2;
+static NTSTATUS add_to_bootstrap(device_extension* Vcb, UINT64 obj_id, UINT8 obj_type, UINT64 offset, void* data, UINT16 size) {
+    sys_chunk* sc;
     LIST_ENTRY* le;
-    
+
     if (Vcb->superblock.n + sizeof(KEY) + size > SYS_CHUNK_ARRAY_SIZE) {
         ERR("error - bootstrap is full\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     sc = ExAllocatePoolWithTag(PagedPool, sizeof(sys_chunk), ALLOC_TAG);
     if (!sc) {
         ERR("out of memory\n");
@@ -3378,46 +3954,47 @@
         ExFreePool(sc);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(sc->data, data, sc->size);
-    
+
     le = Vcb->sys_chunks.Flink;
     while (le != &Vcb->sys_chunks) {
-        sc2 = CONTAINING_RECORD(le, sys_chunk, list_entry);
-        
+        sys_chunk* sc2 = CONTAINING_RECORD(le, sys_chunk, list_entry);
+
         if (keycmp(sc2->key, sc->key) == 1)
             break;
-        
+
         le = le->Flink;
     }
     InsertTailList(le, &sc->list_entry);
-    
+
     Vcb->superblock.n += sizeof(KEY) + size;
-    
+
     regen_bootstrap(Vcb);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS create_chunk(device_extension* Vcb, chunk* c, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS create_chunk(device_extension* Vcb, chunk* c, PIRP Irp) {
     CHUNK_ITEM* ci;
     CHUNK_ITEM_STRIPE* cis;
     BLOCK_GROUP_ITEM* bgi;
     UINT16 i, factor;
     NTSTATUS Status;
-    
+
     ci = ExAllocatePoolWithTag(PagedPool, c->size, ALLOC_TAG);
     if (!ci) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(ci, c->chunk_item, c->size);
-    
-    if (!insert_tree_item(Vcb, Vcb->chunk_root, 0x100, TYPE_CHUNK_ITEM, c->offset, ci, c->size, NULL, Irp, rollback)) {
+
+    Status = insert_tree_item(Vcb, Vcb->chunk_root, 0x100, TYPE_CHUNK_ITEM, c->offset, ci, c->size, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
         ERR("insert_tree_item failed\n");
         ExFreePool(ci);
-        return STATUS_INTERNAL_ERROR;
+        return Status;
     }
 
     if (c->chunk_item->type & BLOCK_FLAG_SYSTEM) {
@@ -3429,7 +4006,7 @@
     }
 
     // add BLOCK_GROUP_ITEM to tree 2
-    
+
     bgi = ExAllocatePoolWithTag(PagedPool, sizeof(BLOCK_GROUP_ITEM), ALLOC_TAG);
     if (!bgi) {
         ERR("out of memory\n");
@@ -3439,13 +4016,14 @@
     bgi->used = c->used;
     bgi->chunk_tree = 0x100;
     bgi->flags = c->chunk_item->type;
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, c->offset, TYPE_BLOCK_GROUP_ITEM, c->chunk_item->size, bgi, sizeof(BLOCK_GROUP_ITEM), NULL, Irp, rollback)) {
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, c->offset, TYPE_BLOCK_GROUP_ITEM, c->chunk_item->size, bgi, sizeof(BLOCK_GROUP_ITEM), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
         ERR("insert_tree_item failed\n");
         ExFreePool(bgi);
-        return STATUS_INSUFFICIENT_RESOURCES;
+        return Status;
     }
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_RAID0)
         factor = c->chunk_item->num_stripes;
     else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
@@ -3458,18 +4036,18 @@
         factor = 1;
 
     // add DEV_EXTENTs to tree 4
-    
+
     cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
-    
+
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
         DEV_EXTENT* de;
-        
+
         de = ExAllocatePoolWithTag(PagedPool, sizeof(DEV_EXTENT), ALLOC_TAG);
         if (!de) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         de->chunktree = Vcb->chunk_root->id;
         de->objid = 0x100;
         de->address = c->offset;
